#include <stdio.h>
#include <stdlib.h>
#include <limits.h>
#include <string.h>
#include <errno.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/poll.h>
#include <fcntl.h>
#include <time.h>
#include <unistd.h>

#include <stdint.h>
#include <sys/time.h>

#include <linux/dvb/frontend.h>
#include <linux/dvb/dmx.h>
#include "lnb.h"

#ifndef TRUE
#define TRUE (1==1)
#endif
#ifndef FALSE
#define FALSE (1==0)
#endif
#define FRONTENDDEVICE "/dev/dvb/adapter%d/frontend0"
  
#define MAXDEVICE 3
 
   static int fefd[MAXDEVICE];
   fe_status_t status;
   fe_status_t statusA[MAXDEVICE];
   fe_status_t statusOLD[MAXDEVICE];
   uint16_t snr, signal;
   uint32_t ber, uncorrected_blocks;
   int timeout = 0;
   struct timeval timeod;
   int xx;
   char fedev[128];
   
  
int main(int argc, char *argv[])
{ 
    for (xx=0;xx<=MAXDEVICE-1;xx++)
     {
       snprintf(fedev, sizeof(fedev), FRONTENDDEVICE, xx);
       if (( fefd[xx] = open(fedev, O_RDONLY | O_NONBLOCK)) < 0) {
          printf("opening frontend %i failed\n",xx);
          return FALSE;
       //status-init :-))
       statusOLD[xx]=0;
      }
     }
do {
   for(xx=0;xx<=MAXDEVICE-1;xx++)
    {       
      if (ioctl(fefd[xx], FE_READ_STATUS, &status ) == -1)
         printf("Adapter %i | FE_READ_STATUS failed", xx);
      statusA[xx]=status;
      //printf ("Adapter %i | status %02x | ", xx, statusA[xx] );
      //if (status & FE_HAS_LOCK)
      //   printf("FE_HAS_LOCK");
      //   printf("\n");

      // a ungetunter adapter liefert immer 00 oder 01, das heißt wir fangen diese beiden ab ggg
      if ( (statusA[xx] != statusOLD[xx]) /* && (statusA[xx] != 0) && (statusA[xx] != 1) */ )
         { gettimeofday( &timeod, 0);
	   printf ("%i.%6i Status Change: Adapter %i | %02x -> %02x ", timeod.tv_sec, timeod.tv_usec, xx, statusOLD[xx], statusA[xx]);
	   if (statusA[xx] & FE_HAS_SIGNAL) 
			{         printf("| FE_HAS_SIGNAL"); 
			} else {  printf("| fe_no__signal"); 
			}
	   if (statusA[xx] & FE_HAS_CARRIER) 
			{         printf("| FE_HAS_CARRIER");
			} else {  printf("| fe_no__carrier");
			}
	   if (statusA[xx] & FE_HAS_VITERBI) 
			{	  printf("| FE_HAS_VITERBI");
			} else {  printf("| fe_no__viterbi");
			}
	   if (statusA[xx] & FE_HAS_SYNC) 
			{	  printf("| FE_HAS_SYNC");
			} else {  printf("| fe_no__synx");
			}
	   if (statusA[xx] & FE_HAS_LOCK)    
			{ 	  printf("| FE_HAS_LOCK");
			} else {  printf("| fe_no__lock");
			}
	   printf("\n");
	 }
      statusOLD[xx] = statusA[xx];
    }
    //halbe sekunde ggg
    //usleep(500000);
    //jetzt 10 ms
    usleep(10000);
   } while (1);

}  
